Imports System.Text

Namespace AstroPhone
	' Move to DLL!!!!!

	Public Class DotRenderer
		Private size As Integer
		Private dotTexture As Texture2D

		Public Sub New(ByVal graphicsDevice As GraphicsDevice, ByVal size As Integer)
			Me.size = size
			dotTexture = New Texture2D(graphicsDevice, size, size)
			Dim pixels(size * size - 1) As UInteger

			' Set all pixels to opaque white
			For i  = 0 To pixels.Length - 1
				pixels(i) = &HFFFFFFFFL
			Next i

			' Now subdivide each pixel into 256 for setting transparency
			Dim center As Integer = 8 *size

			For y  = 0 To 16 * size - 1
				Dim yTexture As Integer = y \ 16

				For x  = 0 To 16 * size - 1
					Dim xTexture As Integer = x \ 16
					Dim index As Integer = yTexture * size + xTexture

					If ((x - center) * (x - center) + (y - center) * (y - center)) > center * center Then
						If pixels(index) >= &H1010101 Then
                            pixels(index) -= CUInt(&H1010101)
						End If
					End If
				Next x
			Next y

			dotTexture.SetData(Of UInteger)(pixels)
		End Sub

		Public Sub Draw(ByVal spriteBatch As SpriteBatch, ByVal center As Vector2, ByVal color As Color)
			spriteBatch.Draw(dotTexture, New Vector2(center.X - size \ 2, center.Y - size \ 2), color)
		End Sub
	End Class
End Namespace
