Namespace AstroPhone
	' Use DLL version from ShowThreeCoordinates!!!

	Public Class LineRenderer
		Private lineTexture As RenderTarget2D

		Public Sub New(ByVal graphicsDevice As GraphicsDevice)
			lineTexture = New RenderTarget2D(graphicsDevice, 2, 3)

			graphicsDevice.SetRenderTarget(lineTexture)
			graphicsDevice.Clear(Color.White)
			graphicsDevice.SetRenderTarget(Nothing)
		End Sub

		Public Sub Draw(ByVal spriteBatch As SpriteBatch, ByVal point1 As Vector2, ByVal point2 As Vector2, ByVal thickness As Single, ByVal color As Color)
			Dim difference As Vector2 = point2 - point1
			Dim length As Single = difference.Length
			Dim angle As Single = CSng(Math.Atan2(difference.Y, difference.X))
			spriteBatch.Draw(lineTexture, point1, Nothing, color, angle, New Vector2(0, 1), New Vector2(length / 2, thickness / 3), SpriteEffects.None, 0)
		End Sub
	End Class
End Namespace
