Imports System.IO
Imports System.Windows
Imports System.Windows.Resources
Imports System.Xml.Serialization

Namespace Petzold.Astronomy
	Public Class Constellations
		Public Sub New()
			Me.ConstellationList = New List(Of Constellation)
		End Sub

		Public Shared Function Load() As Constellations
			' File must be flagged as 'Resource'
            Dim uri As New Uri("Data/constellations.xml", UriKind.Relative)
            Dim resourceInfo As StreamResourceInfo = Application.GetResourceStream(uri)
			Dim serializer As New XmlSerializer(GetType(Constellations))
			Dim constellations As Constellations = Nothing

			Using stream As Stream = resourceInfo.Stream
				constellations = TryCast(serializer.Deserialize(stream), Constellations)
			End Using

			For Each constellation As Constellation In constellations.ConstellationList
				constellation.Initialize()
			Next constellation

			Return constellations
		End Function

		<XmlElement(ElementName := "Constellation")>
		Public Property ConstellationList As List(Of Constellation)
	End Class
End Namespace
