Namespace Petzold.Astronomy
	Public Structure EclipticCoordinate
		Public Sub New(ByVal longitude As Angle, ByVal latitude As Angle, ByVal radius As Double)
            Me.Longitude = longitude
			Me.Latitude = latitude
			Me.Radius = radius
		End Sub

		Public Sub New(ByVal point As Vector3)
            Me.RectangularCoordinates = point
		End Sub

        Private _longitude As Angle
        Public Property Longitude As Angle
            Get
                Return _longitude
            End Get
            Private Set(ByVal value As Angle)
                _longitude = value
            End Set
        End Property

        Private _latitude As Angle
        Public Property Latitude As Angle
            Get
                Return _latitude
            End Get
            Private Set(ByVal value As Angle)
                _latitude = value
            End Set
        End Property

        Private _radius As Double
        Public Property Radius As Double
            Get
                Return _radius
            End Get
            Private Set(ByVal value As Double)
                _radius = value
            End Set
        End Property

		Public Property RectangularCoordinates As Vector3
			Set(ByVal value As Vector3)
				Me.Radius = Math.Sqrt(value.X * value.X + value.Y * value.Y + value.Z * value.Z)

				Me.Longitude = Angle.ArcTangent(-value.Z, value.X)
				Me.Latitude = Angle.ArcTangent(value.Y, Math.Sqrt(value.X * value.X + value.Z * value.Z))
			End Set
			Get
				Dim x As Double = Radius * Latitude.Cosine * Longitude.Cosine
				Dim y As Double = Radius * Latitude.Sine
				Dim z As Double = -Radius * Latitude.Cosine * Longitude.Sine

				Return New Vector3(CSng(x), CSng(y), CSng(z))
			End Get
		End Property

		Public Overrides Function ToString() As String
			Return String.Format("({0}, {1}, {2})", Me.Longitude, Me.Latitude, Me.Radius)
		End Function
	End Structure
End Namespace
