Namespace Petzold.Astronomy
	Public Class HorizontalCoordinateProjection
		Private horzAxis, vertAxis As Vector3

        Private _viewCenterVector As Vector3
        Public Property ViewCenterVector As Vector3
            Get
                Return _viewCenterVector
            End Get
            Protected Set(ByVal value As Vector3)
                _viewCenterVector = value
            End Set
        End Property

		Public Sub SetViewCenter(ByVal viewCenterCoord As HorizontalCoordinate)
			Me.ViewCenterVector = viewCenterCoord.ToVector
			Dim vertAxisCoord As New HorizontalCoordinate(viewCenterCoord.Azimuth + Angle.Right, Angle.Zero)
			vertAxis = vertAxisCoord.ToVector
			horzAxis = Vector3.Cross(Me.ViewCenterVector, vertAxis)
		End Sub

		Public Sub GetAngleOffsets(ByVal objectCoord As HorizontalCoordinate, <System.Runtime.InteropServices.Out> ByRef horzAngle As Angle, <System.Runtime.InteropServices.Out> ByRef vertAngle As Angle)
			Dim objectVector As Vector3 = objectCoord.ToVector
			Dim horzObjectCross As Vector3 = Vector3.Cross(objectVector, -horzAxis)
			Dim vertObjectCross As Vector3 = Vector3.Cross(objectVector, vertAxis)

			horzObjectCross.Normalize()
			vertObjectCross.Normalize()

			Dim x As Double = Vector3.Dot(horzObjectCross, vertAxis)
			Dim y As Double = Vector3.Dot(horzObjectCross, Me.ViewCenterVector)

			horzAngle = -Angle.ArcTangent(y, x)

			x = Vector3.Dot(vertObjectCross, horzAxis)
			y = Vector3.Dot(vertObjectCross, Me.ViewCenterVector)

			vertAngle = -Angle.ArcTangent(y, x)
		End Sub
	End Class
End Namespace
