Imports System.Windows

Namespace Petzold.Astronomy
	Public Class Planet
		Inherits SolarSystemBody

		Private vsop As VsopCruncher

		Public Sub New(ByVal strPlanetAbbreviation As String, ByVal name As String, ByVal color As Color)
			Me.New(strPlanetAbbreviation)
			Me.Name = name
			Me.Color = color
		End Sub

		Protected Sub New(ByVal strPlanetAbbreviation As String)
			vsop = New VsopCruncher(strPlanetAbbreviation)
		End Sub

		Protected Overrides Sub OnTimeChanged()
			Dim latitude As Angle = Angle.FromRadians(vsop.GetLatitude(Me.Time.Tau))
			Dim longitude As Angle = Angle.FromRadians(vsop.GetLongitude(Me.Time.Tau))
			Dim radius As Double = vsop.GetRadius(Me.Time.Tau)

			Me.HeliocentricLocation = New EclipticCoordinate(longitude, latitude, radius).RectangularCoordinates

			MyBase.OnTimeChanged()
		End Sub
	End Class
End Namespace
