Namespace Petzold.Astronomy
	Public Class SolarSystemBody
		Inherits CelestialBody

		Protected Sub New()
		End Sub

		Protected Sub New(ByVal name As String, ByVal color As Color)
			Me.Name = name
			Me.Color = color
		End Sub

        Private _name As String
        Public Property Name As String
            Get
                Return _name
            End Get
            Protected Set(ByVal value As String)
                _name = value
            End Set
        End Property

        Private _color As Color
        Public Property Color As Color
            Get
                Return _color
            End Get
            Protected Set(ByVal value As Color)
                _color = value
            End Set
        End Property

		' Set by descendent classes, used here
        Private _heliocentricLocation As Vector3
        Protected Property HeliocentricLocation As Vector3
            Private Get
                Return _heliocentricLocation
            End Get
            Set(ByVal value As Vector3)
                _heliocentricLocation = value
            End Set
        End Property

		Protected Overrides Sub OnTimeChanged()
			' Calculate geocentric coordinates
			Dim bodyLocation As Vector3 = Me.HeliocentricLocation - Earth.Instance.HeliocentricLocation
			Dim geocentricCoordinate As New EclipticCoordinate(bodyLocation)
            Me.EquatorialCoordinate = Petzold.Astronomy.EquatorialCoordinate.From(geocentricCoordinate, Me.Time)

			MyBase.OnTimeChanged()
		End Sub
	End Class
End Namespace
