Imports System.Xml.Serialization

Namespace Petzold.Astronomy
	Public Class Star
		Inherits CelestialBody

		<XmlAttribute>
		Public Property Number As Integer

		<XmlAttribute>
		Public Property Name As String

		' J2000 in hours
		<XmlAttribute>
		Public Property RightAscension As Double

		' J200 in degrees
		<XmlAttribute>
		Public Property Declination As Double

		<XmlAttribute>
		Public Property Magnitude As Double

		' J2000 in arcsec / year
		<XmlAttribute>
		Public Property RightAscensionProperMotion As Double

		' J2000 in arcsec / year
		<XmlAttribute>
		Public Property DeclinationProperMotion As Double

		<XmlAttribute>
		Public Property LongName As String

		<XmlIgnore>
		Public Property IsConnectedInConstellation As Boolean

		Protected Overrides Sub OnTimeChanged()
			Dim years As Integer = Me.Time.UniversalTime.Year - 2000
			Dim ra As Angle = Angle.FromHours(Me.RightAscension) + Angle.FromHours(0, 0, Me.RightAscensionProperMotion * years)

			Dim dec As Angle = Angle.FromDegrees(Me.Declination) + Angle.FromDegrees(0, 0, Me.DeclinationProperMotion * years)

			Me.EquatorialCoordinate = New EquatorialCoordinate(ra, dec)

			MyBase.OnTimeChanged()
		End Sub
	End Class
End Namespace
